package com.fp.frontend.controller.pgeneral.acco;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ViewScoped;

import org.primefaces.event.SelectEvent;

import com.fp.dto.Request;
import com.fp.dto.Response;
import com.fp.dto.query.DtoQuery;
import com.fp.dto.save.DtoSave;
import com.fp.frontend.controller.AbstractController;
import com.fp.frontend.controller.pgeneral.lov.CatalogLovController;
import com.fp.frontend.helper.MessageHelper;
import com.fp.persistence.pgeneral.acco.TgeneAccountStatus;
import com.fp.persistence.pgeneral.gene.TgeneCatalog;

/**
 * Clase controladora del bean TgeneCatalogDetail.
 *
 * @author Jorge Vaca.
 * @version 2.1
 */
@SuppressWarnings("serial")
@ManagedBean
@ViewScoped
public class AccountStatusController extends AbstractController<TgeneAccountStatus> {

    public AccountStatusController() throws Exception {
        super(TgeneAccountStatus.class);
    }

    @PostConstruct
    private void postconstruct() {
        this.init();
        // Inicializa autoconsulta
        super.startQuery();

    }

    /**
     * Incializa el controlador, cuando se esta utilizando una pagina que utliza
     * el controlador.
     */
    private void init() {
        try {
            this.recperpage = 50; // Cambiar al # reg a mirar.
            this.lrecord = new ArrayList<>();
            this.beanalias = "ACCOUNTSTATUS";
        } catch (Exception e) {
            MessageHelper.setMessageError(e);
        }
    }

    @SuppressWarnings("unchecked")
    @Override
    protected void querydatabase() {
        try {
            DtoQuery dto = super.getDtoQuery(true);
            dto.setOrderby("t.description");

            HashMap<String, DtoQuery> mtables = new HashMap<String, DtoQuery>();
            mtables.put(this.beanalias, dto); // permite adicionar mas de una tabla.

            Request request = this.callerhelper.getRequest();
            request.setQueryTables(mtables);

            Response resp = this.callerhelper.executeQuery(request);

            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) != 0) {
                this.lrecord = new ArrayList<TgeneAccountStatus>();
                MessageHelper.setMessageError(resp);
            } else {
                this.lrecord = (List<TgeneAccountStatus>) resp.get(this.beanalias);
                super.postQuery(this.lrecord);
            }

        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void save() {
        try {
            DtoSave dtosave = super.getDtoSave();
            dtosave.setReturnpk(true); // Para que el core devuelva el pk de los registros nuevos.
            HashMap<String, DtoSave> msave = new HashMap<String, DtoSave>();

            Request request = this.callerhelper.getRequest();
            msave.put(this.beanalias, dtosave); // adicionar metadata de mantenimiento para cada tabla.

            request.setSaveTables(msave);
            Response resp = this.callerhelper.executeSave(request);
            if (resp.getResponseCode().compareTo(Response.RESPONSE_OK) == 0) {
                this.postCommit(resp);
                MessageHelper.setMessageInfo(resp);
            } else {
                MessageHelper.setMessageError(resp);
            }
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
        }
    }

    @Override
    public void postCommit(Response response) throws Exception {
        super.postCommitGeneric(response, this.beanalias);
    }

    public void openCatalogLov() {
        Map<String, List<String>> params = new HashMap<>();
        CatalogLovController.openLov(params);
    }

    public void onReturnCatalogLov(SelectEvent event) throws Exception {
        TgeneCatalog t = (TgeneCatalog) event.getObject();
        super.addFilter("pk.catalogcode", t.getPk());
        super.addField("catalogname", t.getDescription());
        this.query();
    }

    /**
     * Entrega una lista de TgeneAccountStatus.
     *
     * @param modulecode Codigo de modulo a buscar estatus de cuentas.
     * @return
     */
    public static List<TgeneAccountStatus> find(String modulecode) {
        try {
            AccountStatusController asc = new AccountStatusController();
            asc.init();
            asc.recperpage = 300;
            asc.addFilter("pk.modulecode", modulecode);
            asc.addFilter("isaccountstatus", "Y");
            asc.querydatabase();
            if ((asc.lrecord != null) && !asc.lrecord.isEmpty()) {
                return asc.lrecord;
            }
            return null;
        } catch (Throwable e) {
            MessageHelper.setMessageError(e);
            return null;
        }

    }

}
